config/routes.rb
require 'sidekiq/web'

Sidekiq::Web.use Rack::Auth::Basic do |username, password|
  ActiveSupport::SecurityUtils.secure_compare(::Digest::SHA256.hexdigest(username),
                                              ::Digest::SHA256.hexdigest(ENV['ADMIN_USERNAME'])) &
    ActiveSupport::SecurityUtils.secure_compare(::Digest::SHA256.hexdigest(password),
                                                ::Digest::SHA256.hexdigest(ENV['ADMIN_PASSWORD']))
end if Rails.env.production?

Rails.application.routes.draw do
  mount Sidekiq::Web, at: '/sidekiq'

  mount LetterOpenerWeb::Engine, at: '/letter_opener' if Rails.env.development?

  mount Decidim::Core::Engine => '/'

  get 'admin/user_proposal_statistic_report/:slug', to: 'decidim/govbr/user_proposals_statistic_settings#export_user_data', as: 'user_proposal_statistic_report'

  # These two routes are not present anywhere in the product
  # Instead, it's meant to be used by an advanced admin directly on URL
  # This is going to be removed once admin front-end is finished
  get 'admin/user_proposal_statistic_report_force_refresh/:slug', to: 'decidim/govbr/user_proposals_statistic_settings#force_refresh', as: 'user_proposal_statistic_report_force_refresh'
  get 'admin/user_proposal_statistic_report_create/:slug', to: 'decidim/govbr/user_proposals_statistic_settings#create', as: 'user_proposal_statistic_report_create'
end

app/controllers/decidim/proposals/proposals_controller.rb
# frozen_string_literal: true

module Decidim
  module Proposals
    # Exposes the proposal resource so users can view and create them.
    class ProposalsController < Decidim::Proposals::ApplicationController
      helper Decidim::WidgetUrlsHelper
      helper ProposalWizardHelper
      helper ParticipatoryTextsHelper
      helper UserGroupHelper
      include Decidim::ApplicationHelper
      include Flaggable
      include Withdrawable
      include FormFactory
      include FilterResource
      include Decidim::Proposals::Orderable
      include Paginable

      helper_method :proposal_presenter, :form_presenter

      before_action :authenticate_user!, only: [:new, :create, :complete]
      before_action :ensure_is_draft, only: [:compare, :complete, :preview, :publish, :edit_draft, :update_draft, :destroy_draft]
      before_action :set_proposal, only: [:show, :edit, :update, :withdraw]
      before_action :edit_form, only: [:edit_draft, :edit]

      before_action :set_participatory_text

      # rubocop:disable Naming/VariableNumber
      STEP1 = :step_1
      STEP2 = :step_2
      STEP3 = :step_3
      STEP4 = :step_4
      # rubocop:enable Naming/VariableNumber

      def index
        if component_settings.participatory_texts_enabled?
          @proposals = Decidim::Proposals::Proposal
                       .where(component: current_component)
                       .published
                       .not_hidden
                       .only_amendables
                       .includes(:category, :scope, :attachments, :coauthorships)
                       .order(position: :asc)
          render "decidim/proposals/proposals/participatory_texts/participatory_text"
        else
          @base_query = search
                        .result
                        .published
                        .not_hidden

          @proposals = @base_query.includes(:component, :coauthorships, :attachments)
          @all_geocoded_proposals = @base_query.geocoded

          @voted_proposals = if current_user
                               ProposalVote.where(
                                 author: current_user,
                                 proposal: @proposals.pluck(:id)
                               ).pluck(:decidim_proposal_id)
                             else
                               []
                             end

          @user_proposals_statistic = current_user ? Decidim::Govbr::UserProposalsStatistic.by_component(current_component).by_user(current_user).take : nil rescue nil
          # @user_proposals_statistic = Decidim::Govbr::UserProposalsStatistic.new()
          @proposals = reorder(@proposals)
          @proposals = paginate(@proposals)
        end
      end

      def show
        raise ActionController::RoutingError, "Not Found" if @proposal.blank? || !can_show_proposal?
      end

      def new
        enforce_permission_to :create, :proposal
        @step = STEP1
        if proposal_draft.present?
          redirect_to edit_draft_proposal_path(proposal_draft, component_id: proposal_draft.component.id, question_slug: proposal_draft.component.participatory_space.slug)
        else
          @form = form(ProposalWizardCreateStepForm).from_params(body: translated_proposal_body_template)
        end
      end

      def create
        enforce_permission_to :create, :proposal
        @step = STEP1
        @form = form(ProposalWizardCreateStepForm).from_params(proposal_creation_params)

        CreateProposal.call(@form, current_user) do
          on(:ok) do |proposal|
            flash[:notice] = I18n.t("proposals.create.success", scope: "decidim")

            redirect_to "#{Decidim::ResourceLocatorPresenter.new(proposal).path}/compare"
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("proposals.create.error", scope: "decidim")
            render :new
          end
        end
      end

      def compare
        enforce_permission_to :edit, :proposal, proposal: @proposal
        @step = STEP2
        @similar_proposals ||= Decidim::Proposals::SimilarProposals
                               .for(current_component, @proposal)
                               .all

        if @similar_proposals.blank?
          flash[:notice] = I18n.t("proposals.proposals.compare.no_similars_found", scope: "decidim")
          redirect_to "#{Decidim::ResourceLocatorPresenter.new(@proposal).path}/complete"
        end
      end

      def complete
        enforce_permission_to :edit, :proposal, proposal: @proposal
        @step = STEP3

        @form = form_proposal_model

        @form.attachment = form_attachment_new
      end

      def preview
        enforce_permission_to :edit, :proposal, proposal: @proposal
        @step = STEP4
        @form = form(ProposalForm).from_model(@proposal)
      end

      def publish
        enforce_permission_to :edit, :proposal, proposal: @proposal
        @step = STEP4
        PublishProposal.call(@proposal, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("proposals.publish.success", scope: "decidim")
            redirect_to proposal_path(@proposal)
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("proposals.publish.error", scope: "decidim")
            render :edit_draft
          end
        end
      end

      def edit_draft
        @step = STEP3
        enforce_permission_to :edit, :proposal, proposal: @proposal
      end

      def update_draft
        @step = STEP1
        enforce_permission_to :edit, :proposal, proposal: @proposal

        @form = form_proposal_params
        UpdateProposal.call(@form, current_user, @proposal) do
          on(:ok) do |proposal|
            flash[:notice] = I18n.t("proposals.update_draft.success", scope: "decidim")
            redirect_to "#{Decidim::ResourceLocatorPresenter.new(proposal).path}/preview"
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("proposals.update_draft.error", scope: "decidim")
            render :edit_draft
          end
        end
      end

      def destroy_draft
        enforce_permission_to :edit, :proposal, proposal: @proposal

        DestroyProposal.call(@proposal, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("proposals.destroy_draft.success", scope: "decidim")
            redirect_to new_proposal_path
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("proposals.destroy_draft.error", scope: "decidim")
            render :edit_draft
          end
        end
      end

      def edit
        enforce_permission_to :edit, :proposal, proposal: @proposal
      end

      def update
        enforce_permission_to :edit, :proposal, proposal: @proposal

        @form = form_proposal_params
        UpdateProposal.call(@form, current_user, @proposal) do
          on(:ok) do |proposal|
            flash[:notice] = I18n.t("proposals.update.success", scope: "decidim")
            redirect_to Decidim::ResourceLocatorPresenter.new(proposal).path
          end

          on(:invalid) do
            flash.now[:alert] = I18n.t("proposals.update.error", scope: "decidim")
            render :edit
          end
        end
      end

      def withdraw
        enforce_permission_to :withdraw, :proposal, proposal: @proposal

        WithdrawProposal.call(@proposal, current_user) do
          on(:ok) do
            flash[:notice] = I18n.t("proposals.update.success", scope: "decidim")
            redirect_to Decidim::ResourceLocatorPresenter.new(@proposal).path
          end
          on(:has_supports) do
            flash[:alert] = I18n.t("proposals.withdraw.errors.has_supports", scope: "decidim")
            redirect_to Decidim::ResourceLocatorPresenter.new(@proposal).path
          end
        end
      end

      private

      def search_collection
        Proposal.where(component: current_component).published.not_hidden.with_availability(params[:filter].try(:[], :with_availability))
      end

      def default_filter_params
        {
          search_text_cont: "",
          with_any_origin: default_filter_origin_params,
          activity: "all",
          with_any_category: default_filter_category_params,
          with_any_state: %w(accepted evaluating state_not_published),
          with_any_scope: default_filter_scope_params,
          related_to: "",
          type: "all"
        }
      end

      def default_filter_origin_params
        filter_origin_params = %w(participants meeting)
        filter_origin_params << "official" if component_settings.official_proposals_enabled
        filter_origin_params << "user_group" if current_organization.user_groups_enabled?
        filter_origin_params
      end

      def proposal_draft
        Proposal.from_all_author_identities(current_user).not_hidden.only_amendables
                .where(component: current_component).find_by(published_at: nil)
      end

      def ensure_is_draft
        @proposal = Proposal.not_hidden.where(component: current_component).find(params[:id])
        redirect_to Decidim::ResourceLocatorPresenter.new(@proposal).path unless @proposal.draft?
      end

      def set_proposal
        @proposal = Proposal.published.not_hidden.where(component: current_component).find_by(id: params[:id])
      end

      # Returns true if the proposal is NOT an emendation or the user IS an admin.
      # Returns false if the proposal is not found or the proposal IS an emendation
      # and is NOT visible to the user based on the component's amendments settings.
      def can_show_proposal?
        return true if @proposal&.amendable? || current_user&.admin?

        Proposal.only_visible_emendations_for(current_user, current_component).published.include?(@proposal)
      end

      def proposal_presenter
        @proposal_presenter ||= present(@proposal)
      end

      def form_proposal_params
        form(ProposalForm).from_params(params)
      end

app/views/decidim/proposals/proposals/_filters.html.erb
<%= filter_form_for filter do |form| %>

  <%= form.hidden_field "state_withdraw", value: params.dig("filter", "state_withdraw") %>

  <% if component_settings.proposal_answering_enabled && current_settings.proposal_answering_enabled %>
    <%= form.check_boxes_tree :with_any_state, filter_proposals_state_values, legend_title: t(".state"), "aria-controls": "proposals" %>
  <% end %>

  <% if current_component.has_subscopes? %>
    <%= form.check_boxes_tree :with_any_scope, filter_scopes_values, legend_title: t(".scope"), "aria-controls": "proposals" %>
  <% end %>

  <% if current_component.categories.any? %>
    <%= form.check_boxes_tree :with_any_category, filter_categories_values, legend_title: t(".category"), "aria-controls": "proposals" %>
  <% end %>

  <% if component_settings.official_proposals_enabled %>
    <%= form.check_boxes_tree :with_any_origin, filter_origin_values, legend_title: t(".origin"), "aria-controls": "proposals" %>
  <% end %>

  <% if @proposals.only_emendations.any? %>
    <%= form.collection_radio_buttons :type, filter_type_values, :first, :last, { legend_title: t(".amendment_type") }, "aria-controls": "proposals" %>
  <% end %>

  <% if linked_classes_for(Decidim::Proposals::Proposal).any? %>
    <%= form.collection_radio_buttons :related_to, linked_classes_filter_values_for(Decidim::Proposals::Proposal), :first, :last, { legend_title: t(".related_to") }, "aria-controls": "proposals" %>
  <% end %>

  <%= hidden_field_tag :order, order, id: nil, class: "order_filter" %>
<% end %>

app/views/decidim/proposals/proposals/_filters_small_view.html.erb
<div class="statistics-controls">
  <button data-open="filter-box" aria-controls="filter-box" aria-haspopup="dialog">
    <span class="proposals__button-circle button-container-style">
      <i class="fas fa-sliders-h size-icon-filter"></i>
    </span>
  </button>
</div>

<div class="reveal" id="filter-box" data-reveal role="dialog" aria-modal="true" aria-labelledby="filter-box-label">
  <div class="reveal__header">
    <h3 id="filter-box-label" class="reveal__title"><%= t ".filter_by" %>:</h3>
    <button class="close-button" data-close aria-label="<%= t(".close_modal") %>" type="button">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="filters">
    <%= render partial: "filters" %>
  </div>
</div>

app/views/decidim/proposals/proposals/_proposals.html.erb
<% if params.dig("filter", "with_availability").present? && params["filter"]["with_availability"] == "withdrawn" %>
  <div class="callout warning">
    <%= t("decidim.proposals.proposals.index.text_banner",
          go_back_link: link_to(t("decidim.proposals.proposals.index.click_here"), proposals_path("filter[with_availability]" => nil)),
          ).html_safe %>
  </div>
<% end %>

<div class="proposals-container">
  <p id="proposals-count" class="proposals-counter">
      <%= render partial: "count" %>
  </p>

  <div class="order__by-text">
    <%= order_selector available_orders, i18n_scope: "decidim.proposals.proposals.orders" %>
  </div>  
</div>

<div class="card-grid proposals-content">
  <%= render @proposals %>
</div>

<%= render partial: "decidim/shared/results_per_page" %>

<div class="row">
  <div class="columns mediumlarge-8 large-9">
    <% if @proposals.empty? %>
      <div class="callout secondary">
        <% if params[:filter].present? %>
          <p><%= t(".empty_filters") %></p>
        <% else %>
          <p><%= t(".empty") %></p>
        <% end %>
      </div>
    <% end %>
  </div>
</div>

<%= decidim_paginate @proposals %>

<div class="row">
  <div class="text-right">
    <% if params.dig("filter", "with_availability").present? && params["filter"]["with_availability"] == "withdrawn" %>
      <%= link_to t("decidim.proposals.proposals.index.see_all"), proposals_path("filter[with_availability]" => nil) %>
    <% else %>
      <%= link_to t("decidim.proposals.proposals.index.see_all_withdrawn"), proposals_path(filter: { with_availability: "withdrawn", state: [""] }) %>
    <% end %>
  </div>
</div>

app/views/decidim/proposals/proposals/_statistics.html.erb
<div class="br-list" role="list">
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Número de propostas criadas </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.proposals_done : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Número de comentários feitos </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.comments_done : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Número de votos dados </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.votes_done : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Votos recebidos nas suas propostas </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.votes_received : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Comentários recebidos </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.comments_received : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Número de propostas seguidas </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.follows_done : 0%> </div>
        </div>
    </div>
    <span class="br-divider"></span>
    <div class="br-item">
        <div class="lt-row" role="listitem">
            <div class="statistics__list-item">Seguidores nas suas propostas </div>
            <div class="statistics__count text-blue-warm-vivid-70"> <%=statistics ? statistics.follows_received : 0%> </div>
        </div>
    </div>
</div>

app/views/decidim/proposals/proposals/_statistics_small_view.html.erb
<div class="scrimutilexemplo">
  <button data-open="statistics-box" aria-controls="statistics-box" aria-haspopup="dialog"  type="button">
    <span class="proposals__button-circle button-container-style">
      <i class="fas fa-chart-bar size-icon-filter"></i>
    </span> 
  </button>
</div>

<div class="br-scrim-util foco" id="scrimutilexample" data-scrim="true">
  <div class="br-modal">
    <div class="br-modal-header">Minhas estatísticas <%=@statistics%>
      <button class="br-button close circle" type="button"
        id="scrimfechar" data-dismiss="scrimexample">
        <i class="fas fa-times" aria-hidden="true"></i>
      </button>
    </div>
    <div class="br-modal-body">
      <%= render partial: "statistics", :locals => {:statistics => statistics} %>
    </div>
  </div>
</div>

app/views/decidim/proposals/proposals/index.html.erb
<div class="br-container-lg">
  <% if component_settings.geocoding_enabled? %>
    <%= dynamic_map_for proposals_data_for_map(@all_geocoded_proposals) do %>
      <template id="marker-popup">
        <div class="map-info__content">
          <h3>${title}</h3>
          <div id="bodyContent">
            <p>{{html body}}</p>
            <div class="map__date-address">
              <div class="address card__extra">
                <div class="address__icon">{{html icon}}</div>
                <div class="address__details">
                  <span>${address}</span><br>
                </div>
              </div>
            </div>
            <div class="map-info__button">
              <a href="${link}" class="button button--sc">
                <%= t(".view_proposal") %>
              </a>
            </div>
          </div>
        </div>
      </template>
    <% end %>
  <% end %>

  <%= render partial: "decidim/shared/component_announcement" %>

  <%= render partial: "voting_rules" %>

  <div class="filter-container">
    <% if current_user %>
      <h2 class="user-name-title-h1">Olá, <%= current_user.name %></h2>
    <% end %>
    <div class="proposals__buttons-container">
      <div class="proposals-button__container">
        <%= render partial: "statistics_small_view", locals: {statistics: @user_proposals_statistic}%>
      </div>
      <div class="proposals-button__container">
        <%= render partial: "filters_small_view" %>
      </div>
    </div>
  </div>

  <div class="br-row">
    <div class="title-action title-action-button">
      <% if current_settings.creation_enabled && current_component.participatory_space.can_participate?(current_user) %>
        <%= action_authorized_link_to :create, new_proposal_path,
          class: "title-action__action br-button block primary", data: { "redirect_url" => new_proposal_path } do %>
          <i class="fa-solid fa-plus fa-sl"></i>
          <span class="title-action-text">Faça sua proposta</span>
        <% end %>
      <% end %>

      <% if component_settings.collaborative_drafts_enabled? %>
        <%= link_to t(".collaborative_drafts_list"), collaborative_drafts_path, class: "title-action__action button small hollow ml-s" %>
      <% end %>
    </div>
    <%= filter_form_for filter do |form| %>
      <div class="br-input input-highlight">
        <%= form.search_field :search_text_cont, type: "search",
          label: false, class: "input-group-field", placeholder: "Digite uma palavra",
          "aria-label": "Buscar", id: "input-search-large",
          data: { disable_dynamic_change: true } %>
          <button class="br-button" type="submit" aria-label="Buscar">
            <i class="fas fa-search" aria-hidden="true"></i>
          </button>
      </div>
    <% end %>
    <div id="proposals" aria-live="polite">
      <%= render partial: "proposals" %>
    </div>
  </div>
</div>

app/views/decidim/proposals/proposals/index.js.erb
var $proposals = $('#proposals');
var $proposalsCount = $('#proposals-count');
var $orderFilterInput = $('.order_filter');

$proposals.html('<%= j(render partial: "proposals").strip.html_safe %>');
$proposalsCount.html('<%= j(render partial: "count").strip.html_safe %>');
$orderFilterInput.val('<%= order %>');

var $dropdownMenu = $('.dropdown.menu', $proposals);
$dropdownMenu.foundation();